/*
 * This file is part of RML Development Tooling.
 *
 * Copyright (c) 2006, Adrian Pop, adrpo@ida.liu.se
 */

package org.pelab.rml.editor;

import org.eclipse.ui.editors.text.TextEditor;
import org.eclipse.ui.IEditorInput;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.source.SourceViewerConfiguration;

import org.pelab.rml.RMLPlugin;
import org.pelab.rml.editor.utils.RMLColorManager;
import org.pelab.rml.preferences.RMLPreferencePage;

/**
 * @author Adrian Pop
 */
public class RMLEditor extends TextEditor 
{
	public static final String ID = RMLEditor.class.getName();
	
	private RMLColorManager colorManager;

	public RMLEditor()
	{
		super();
		SourceViewerConfiguration sourceViewerConfig = new RMLSourceViewerConfig();
		setDocumentProvider(new RMLDocumentProvider());
		//setDocumentProvider(new org.eclipse.ui.editors.text.TextFileDocumentProvider());
		setSourceViewerConfiguration(sourceViewerConfig);
		
		//colorManager = new RMLColorManager();
		//setSourceViewerConfiguration(new RMLConfiguration(colorManager));

		
		/* adrpo, 2006-02-06 TODO!! fix tab width!
		ScopedPreferenceStore store = (ScopedPreferenceStore)super.getPreferenceStore();
		if (store.contains("Default tab width"))
		{
			System.err.println(store.getDefaultInt("Default tab width"));
		}
		else
		{
			System.err.println("No default tab width");
		}
		
		for (int i = 0; i < names.length; i++)
		super.setPreferenceStore(store); */
	}
	
	public void dispose() {
		//colorManager.dispose();
		super.dispose();
	}
    /** The <code>RMLEditor</code> implementation of this 
     * <code>AbstractTextEditor</code> method performs any extra 
     * save behavior required by the RML editor.
     */
    public void doSave(IProgressMonitor monitor) {
    	super.doSave(monitor);
    
    	// compile or not, according to the user preferences
    	if (RMLPlugin.getDefault().getPreferenceStore().getBoolean(RMLPreferencePage.AUTO_COMPILE)) {
    		IAction a = RMLCompilerAction.getInstance();
    		if (a != null)
    			a.run();
    	}
    }

    public void doSetInput( final IEditorInput input ) throws CoreException
    {
    	super.doSetInput(input);
    }
}
