package org.pelab.rml.views;

import org.eclipse.jface.text.rules.DefaultPartitioner;
import org.eclipse.jface.text.rules.RuleBasedPartitionScanner;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.ui.console.IConsoleDocumentPartitioner;
import org.eclipse.ui.console.IConsoleView;
import org.eclipse.ui.console.TextConsole;
import org.eclipse.ui.console.TextConsolePage;
import org.eclipse.ui.part.IPageBookViewPage;
import org.pelab.rml.RMLPlugin;


public class RMLTextConsole extends TextConsole {
	
	public final static String CONSOLE_TYPE = "RMLTextConsole";
	private RMLConsolePartitioner partitioner = new RMLConsolePartitioner();
	
	public RMLTextConsole() 
	{
		super("RML+MMC Console", CONSOLE_TYPE, RMLPlugin.getImageDescriptor("icons/RML-ICO.gif"), true);
		getDocument().set("");
		partitioner.connect(getDocument());
	}	
	
	class RMLConsolePartitioner extends DefaultPartitioner implements IConsoleDocumentPartitioner {

        public RMLConsolePartitioner() {
            super(new RuleBasedPartitionScanner(), null);
            getDocument().setDocumentPartitioner(this);
        }

        /*
         * (non-Javadoc)
         * 
         * @see org.eclipse.ui.console.IConsoleDocumentPartitioner#isReadOnly(int)
         */
        public boolean isReadOnly(int offset) {
            return false;
        }

        /*
         * (non-Javadoc)
         * 
         * @see org.eclipse.ui.console.IConsoleDocumentPartitioner#computeStyleRange(int,
         *      int)
         */
        public StyleRange[] getStyleRanges(int offset, int length) {
            return null;
        }

    }
	
	protected IConsoleDocumentPartitioner getPartitioner()
	{		
		return new RMLConsolePartitioner();
	}
	
	public IPageBookViewPage createPage(IConsoleView view)
	{
		return new TextConsolePage(this, view);
	}
		
    protected void init() {

    }
    
    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.ui.console.AbstractConsole#dispose()
     */
    protected void dispose() {
        super.dispose();
    }	
}		
